package com.jpsoft.smart.modules.base.dao;

import cn.hutool.core.date.DateTime;
import com.jpsoft.smart.modules.base.entity.CompanyInfo;
import com.jpsoft.smart.modules.base.entity.PersonDeviceFilterLog;
import com.jpsoft.smart.modules.base.entity.PersonDeviceLog;
import com.jpsoft.smart.modules.base.entity.PersonInfo;
import com.jpsoft.smart.modules.common.dto.Sort;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @author 墨鱼_mo
 * @date 2020-3-15 14:22
 */
@Repository
public interface PersonDeviceLogDAO {


    void insert(PersonDeviceLog personDeviceLog);

    List<PersonDeviceLog> search(Map<String, Object> searchParams, List<Sort> sortList);

    List<PersonDeviceLog> simpleSearch(Map<String, Object> searchParams, List<Sort> sortList);

    List<PersonDeviceLog> findByPersonAndDate(@Param("personId") Long personId, @Param("startDate")Date startDate, @Param("endDate")Date endDate);

    PersonDeviceLog  get(String id);

    List<PersonInfo> queryUnAttendanceList(String companyCode, Date startTime, Date endTime);
    List<PersonInfo> queryAttendanceList(String companyCode, Date startTime, Date endTime);

    PersonDeviceLog findLastPersonLog(Long personId, float temperatureMax);

    Integer getDayCheckedVistorNumByDeviceNoList(@Param("startTime") Date startTime, @Param("endTime") Date endTime, @Param("list") List<String> list);

    List<PersonDeviceLog> findAllPersonLogByCompanyIdAndDeviceNo(@Param("startTime") Date startTime, @Param("endTime") Date endTime,
                                                                 @Param("companyList") List<CompanyInfo> companyList,
                                                                 @Param("deviceNoList") List<String> deviceNoList);

    List<PersonDeviceLog> findLastPersonLogByCompanyList(@Param("startTime") Date startTime, @Param("endTime") Date endTime, @Param("companyList") List<CompanyInfo> list);

    List<PersonDeviceLog> findVisitorLogByDeviceNoList(@Param("startTime") Date startTime, @Param("endTime") Date endTime, @Param("list") List<String> list);

    List<PersonDeviceLog> findLastTeacherLogByCompanyList(@Param("startTime") Date startTime, @Param("endTime") Date endTime, @Param("list") List<CompanyInfo> list);

    List<PersonDeviceLog> findLastStudentLogByCompanyList(@Param("startTime") Date startTime, @Param("endTime") Date endTime, @Param("list") List<CompanyInfo> list);

    Integer getDayCheckedPersonNumByCompanyList(@Param("startTime") Date startTime, @Param("endTime") Date endTime, @Param("list") List<CompanyInfo> list,  @Param("popedom") String popedom);

    int delete(String id);

    List<PersonDeviceLog> findExpiredVisitorRecord(@Param("limit") int limit);

    long countByAttendance(String companyCode, Date beginDate, Date endDate);

    Integer getDayAbnormalNumByDeviceNoList(Date startTime, Date endTime, List<String> list, float temperatureMax);
}
