package com.jpsoft.smart.modules.base.dao;

import java.util.List;

import com.jpsoft.smart.modules.base.entity.CompanyInfo;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;
import com.jpsoft.smart.modules.base.entity.PersonInfo;
import java.util.Map;
import com.jpsoft.smart.modules.common.dto.Sort;

@Repository
public interface PersonInfoDAO {
	int insert(PersonInfo entity);
	int update(PersonInfo entity);
	int exist(Long id);
	PersonInfo get(Long id);
	int delete(Long id);
	List<PersonInfo> list();
	List<PersonInfo> search(Map<String, Object> searchParams, List<Sort> sortList);
    PersonInfo findByNameAndPhone(String name, String phone);
	PersonInfo findByOpenId(String openId);
    List<PersonInfo> findByCompanyId(String companyId);
    long countByCompanyCode(String code,Long personId);

	PersonInfo getIgnoreDelFlag(Long id);
	List<PersonInfo> findByCompanyCode(Map<String,Object> searchParams,List<Sort> sortList);

    long countByCompanyList(List<CompanyInfo> list);

    long countByCompanyListAndPopedom(@Param("type") String type, @Param("list") List<CompanyInfo> list);

	long countStudentByCompanyListAndPopedom(@Param("type") String type, @Param("list")List<CompanyInfo> list);

	PersonInfo findById(long id);

    long countByCompanyId(String companyId);

    long countByCompanyIds(List<String> companyIds);

    PersonInfo findByIdCardAndCompanyId(String idCard,String companyId);

	List<PersonInfo> notGuestList();
}