package com.jpsoft.smart.modules.base.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;

/**
  描述:base_company_info的实体类
 */
@Data
@ApiModel(value = "base_company_info的实体类")
public class CompanyInfo {
    @ApiModelProperty(value = "公司编号")
	private String id;
	@ApiModelProperty(value = "公司logo")
	private String logo;
    @ApiModelProperty(value = "序号")
	private Integer sortNo;
    @ApiModelProperty(value = "公司名称")
	private String name;
	@ApiModelProperty(value = "公司简称")
	private String shortName;
    @ApiModelProperty(value = "备注")
	private String remark;
    @ApiModelProperty(value = "创建人")
	private String createBy;
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "创建时间")
	private Date createTime;
    @ApiModelProperty(value = "更新人")
	private String updateBy;
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "更新时间")
	private Date updateTime;
    @ApiModelProperty(value = "是否删除")
	private Boolean delFlag;
	@ApiModelProperty(value = "上级公司")
	private String parentId;
	@ApiModelProperty(value = "企业编码")
	private String code;
	@ApiModelProperty(value = "上级单位")
	private String parentName;
	@ApiModelProperty(value = "单位性质")
	private String type;
	@ApiModelProperty(value = "单位性质翻译")
	private String typeN;
	@ApiModelProperty(value = "大屏公示墙网址")
	private String wallUrl;
}