package com.jpsoft.smart.modules.base.service;

import cn.hutool.core.date.DateTime;
import cn.hutool.json.JSONObject;
import com.jpsoft.smart.modules.base.entity.CompanyInfo;
import com.jpsoft.smart.modules.base.entity.PersonDeviceFilterLog;
import com.jpsoft.smart.modules.base.entity.PersonDeviceLog;
import com.jpsoft.smart.modules.base.entity.PersonInfo;
import com.jpsoft.smart.modules.common.dto.Sort;
import com.github.pagehelper.Page;

import java.io.IOException;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @author 墨鱼_mo
 * @date 2020-3-15 14:12
 */
public interface PersonDeviceLogService {

    /**
     * 设备自动上传的过人记录
     * @param deviceNo
     * @param temperature
     * @param faceImageJson
     * @param libMatInfoListJson
     * @param matchPersonInfo
     */
    void deviceInsertLog(String deviceNo, BigDecimal temperature, JSONObject faceImageJson, JSONObject libMatInfoListJson, JSONObject matchPersonInfo, Date date,Integer maskFlag);
    Page<PersonDeviceLog> pageSearch(Map<String, Object> searchParams, int pageNum, int pageSize,boolean count, List<Sort> sortList);
    List<PersonDeviceLog> findByPersonAndDate(Long personId,Date startDate,Date endDate);
    Page<PersonDeviceLog> simplePageSearch(Map<String, Object> searchParams, int pageNum, int pageSize,boolean count, List<Sort> sortList);
    PersonDeviceLog get(String id);
    List<PersonInfo> queryUnAttendanceList(String companyCode, Date startTime, Date endTime);
    List<PersonInfo> queryAttendanceList(String companyCode, Date startDate, Date endDate);
    PersonDeviceLog findLastPersonLog(Long personId, float temperatureMax);

    Integer getDayCheckedVistorNumByDeviceNoList(Date startTime, Date endTime, List<String> deviceNoList);

    Page<PersonDeviceLog> findLastPersonLogByCompanyList(DateTime beginOfDay, DateTime endOfDay, List<CompanyInfo> list,int pageNum, int pageSize);

    Page<PersonDeviceLog> findVisitorLogByDeviceNoList(DateTime beginOfDay, DateTime endOfDay, List<String> deviceNoList, int pageIndex, int pageSize);

    Page<PersonDeviceLog> findAllPersonLogByCompanyListAndDeviceNoList(DateTime beginOfDay, DateTime endOfDay, List<CompanyInfo> companyList,List<String> deviceList, int pageIndex, int pageSize);

    Page<PersonDeviceLog> findLastTeacherLogByCompanyList(Date beginOfDay, Date endOfDay, List<CompanyInfo> list, int pageIndex, int pageSize);

    Page<PersonDeviceLog> findLastStudentLogByCompanyList(Date beginOfDay, Date endOfDay, List<CompanyInfo> list, int pageIndex, int pageSize);

    Integer getDayCheckedPersonTotalByCompanyList(Date startTime,Date endTime, List<CompanyInfo> list,String popedom);

    List<PersonDeviceLog> findExpiredVisitorRecord(int limit);

    int delete(String id);

    long countByAttendance(String companyCode, Date beginDate, Date endDate);

    Integer getDayAbnormalNumByDeviceNoList(DateTime dateTime, Date date, List<String> deviceNoList);
}
