package com.jpsoft.smart.modules.base.service.impl;

import java.util.*;
import javax.annotation.Resource;

import com.jpsoft.smart.modules.base.dao.CompanyInfoDAO;
import com.jpsoft.smart.modules.base.entity.CompanyInfo;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import com.jpsoft.smart.modules.base.dao.AlarmConfigDAO;
import com.jpsoft.smart.modules.base.entity.AlarmConfig;
import com.jpsoft.smart.modules.base.service.AlarmConfigService;
import com.github.pagehelper.Page;
import com.jpsoft.smart.modules.common.dto.Sort;
import com.github.pagehelper.PageHelper;

@Transactional
@Component(value="alarmConfigService")
public class AlarmConfigServiceImpl implements AlarmConfigService {
	@Resource(name="alarmConfigDAO")
	private AlarmConfigDAO alarmConfigDAO;

	@Resource(name="companyInfoDAO")
	private CompanyInfoDAO companyInfoDAO;

	@Override
	public AlarmConfig get(String id) {
		// TODO Auto-generated method stub
		return alarmConfigDAO.get(id);
	}

	@Override
	public int insert(AlarmConfig model) {
		// TODO Auto-generated method stub
		//model.set${PkFieldName}(UUID.randomUUID().toString());
		
		return alarmConfigDAO.insert(model);
	}

	@Override
	public int update(AlarmConfig model) {
		// TODO Auto-generated method stub
		return alarmConfigDAO.update(model);		
	}

	@Override
	public int delete(String id) {
		// TODO Auto-generated method stub
		return alarmConfigDAO.delete(id);
	}

	@Override
	public boolean exist(String id) {
		// TODO Auto-generated method stub
		int count = alarmConfigDAO.exist(id);
		
		return count > 0 ? true : false;
	}
	
	@Override
	public List<AlarmConfig> list() {
		// TODO Auto-generated method stub
		return alarmConfigDAO.list();
	}
		
	@Override
	public Page<AlarmConfig> pageSearch(Map<String, Object> searchParams, int pageNumber, int pageSize,boolean count,List<Sort> sortList) {
        Page<AlarmConfig> page = PageHelper.startPage(pageNumber,pageSize,count).doSelectPage(()->{
            alarmConfigDAO.search(searchParams,sortList);
        });
        
        return page;
	}

	@Override
	public List<AlarmConfig> findByCompanyId(String companyId) {
		return alarmConfigDAO.findByCompanyId(companyId);
	}

	@Override
	public Set<Integer> getWeekdaySetByCompanyId(String companyId) {
		CompanyInfo companyInfo = companyInfoDAO.get(companyId);
		String[] arr = companyInfo.getCode().split(",");

		Set<Integer> weekdaySet = new TreeSet<>();

		List<AlarmConfig> configList = null;

		for (int i=arr.length-1;i>=0;i--) {
			configList = findByCompanyId(arr[i]);

			if (configList!=null && configList.size()>0){
				break;
			}
		}

		for (AlarmConfig alarmConfig : configList) {
			String[] weekdays = alarmConfig.getWeekdays().split(",");

			for (String weekday : weekdays) {
				weekdaySet.add(Integer.valueOf(weekday));
			}
		}

		return weekdaySet;
	}
}