package com.jpsoft.smart.modules.base.service.impl;

import com.jpsoft.smart.modules.base.dao.ParkingRecordDAO;
import com.jpsoft.smart.modules.base.entity.ParkingRecord;
import com.jpsoft.smart.modules.base.service.ParkingRecordService;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;

/**
 * @author 墨鱼_mo
 * @date 2020-4-14 9:38
 */
@Transactional
@Component(value="parkingRecordService")
public class ParkingRecordServiceImpl implements ParkingRecordService {

    @Resource(name="parkingRecordDAO")
    private ParkingRecordDAO parkingRecordDAO;

    @Override
    public void insert(ParkingRecord parkingRecord) {
        parkingRecordDAO.insert(parkingRecord);
    }

    @Override
    public ParkingRecord get(String id) {
        return parkingRecordDAO.findById(id);
    }

    @Override
    public void update(ParkingRecord parkingRecord) {
        parkingRecordDAO.update(parkingRecord);
    }

    @Override
    public ParkingRecord findBySerialNumber(String outTradeNo) {
        return parkingRecordDAO.findBySerialNumber(outTradeNo);
    }
}
