package com.jpsoft.smart.modules.base.service.impl;

import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.UUID;
import javax.annotation.Resource;

import com.jpsoft.smart.modules.base.entity.CompanyInfo;
import com.jpsoft.smart.modules.base.entity.DeviceInfo;
import com.jpsoft.smart.modules.base.service.DeviceInfoService;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import com.jpsoft.smart.modules.base.dao.PersonInfoDAO;
import com.jpsoft.smart.modules.base.entity.PersonInfo;
import com.jpsoft.smart.modules.base.service.PersonInfoService;
import com.github.pagehelper.Page;
import com.jpsoft.smart.modules.common.dto.Sort;
import com.github.pagehelper.PageHelper;

@Transactional
@Component(value="personInfoService")
public class PersonInfoServiceImpl implements PersonInfoService {
	@Resource(name="personInfoDAO")
	private PersonInfoDAO personInfoDAO;

	@Autowired
	private DeviceInfoService deviceInfoService;

	@Override
	public PersonInfo get(Long id) {
		// TODO Auto-generated method stub
		return personInfoDAO.get(id);
	}

	@Override
	public int insert(PersonInfo model) {
		// TODO Auto-generated method stub
		//model.setId(UUID.randomUUID().toString());

		return personInfoDAO.insert(model);
	}

	@Override
	public int update(PersonInfo model) {
		// TODO Auto-generated method stub
		return personInfoDAO.update(model);
	}

	@Override
	public int delete(Long id) {
		// TODO Auto-generated method stub
		return personInfoDAO.delete(id);
	}

	@Override
	public boolean exist(Long id) {
		// TODO Auto-generated method stub
		int count = personInfoDAO.exist(id);

		return count > 0 ? true : false;
	}

	@Override
	public List<PersonInfo> list() {
		// TODO Auto-generated method stub
		return personInfoDAO.list();
	}

	@Override
	public Page<PersonInfo> pageSearch(Map<String, Object> searchParams, int pageNumber, int pageSize,boolean count,List<Sort> sortList) {
        Page<PersonInfo> page = PageHelper.startPage(pageNumber,pageSize,count).doSelectPage(()->{
            personInfoDAO.search(searchParams,sortList);
        });

        return page;
	}

	@Override
	public PersonInfo findByNameAndPhone(String name, String phone) {
		return personInfoDAO.findByNameAndPhone(name,phone);
	}

	@Override
	public PersonInfo findByOpenId(String openId) {
		return personInfoDAO.findByOpenId(openId);
	}

	@Override
	public List<PersonInfo> findByCompanyId(String companyId) {
		return personInfoDAO.findByCompanyId(companyId);
	}

	@Override
	public long countByCompanyCode(String code,Long relatePersonId) {
		return personInfoDAO.countByCompanyCode(code, relatePersonId);
	}

	@Override
	public List<PersonInfo> findByCompanyCode(Map<String,Object> searchParams,List<Sort> sortList) {
		return personInfoDAO.findByCompanyCode(searchParams,sortList);
	}

	@Override
	public long countByCompanyList(List<CompanyInfo> list) {
		return personInfoDAO.countByCompanyList(list);
	}

	@Override
	public long countByCompanyListAndPopedom(String type,List<CompanyInfo> list) {
		if ("teacher".equals(type)){
			return personInfoDAO.countByCompanyListAndPopedom("%2%",list);
		}
		if ("student".equals(type)){
			return personInfoDAO.countStudentByCompanyListAndPopedom("1",list);
		}
		return 0L;
	}

	@Override
	public PersonInfo findById(long longValue) {
		return personInfoDAO.findById(longValue);
	}

	@Override
	public PersonInfo getIgnoreDelFlag(Long id) {
		return personInfoDAO.getIgnoreDelFlag(id);
	}

	@Override
	public long countByCompanyId(String companyId) {
		return personInfoDAO.countByCompanyId(companyId);
	}

	@Override
	public long countByCompanyIds(List<String> companyIds) {
		return personInfoDAO.countByCompanyIds(companyIds);
	}

	@Override
	public PersonInfo addPersonForCompany(PersonInfo personInfo, String deviceNo) {

		if (StringUtils.isNotBlank(personInfo.getName()) && StringUtils.isNotBlank(personInfo.getIdCard()) && personInfo.getId()==0){
			DeviceInfo deviceInfo = deviceInfoService.getByDeviceNo(deviceNo);
			if (deviceInfo!=null){
				PersonInfo personInfo1 = personInfoDAO.findByIdCardAndCompanyId(personInfo.getIdCard(),deviceInfo.getCompanyId());
				if (personInfo1 == null){
					PersonInfo personInfo2 = new PersonInfo();
					personInfo2.setCompanyId(deviceInfo.getCompanyId());
					personInfo2.setName(personInfo.getName());
					personInfo2.setIdCard(personInfo.getIdCard());
					personInfo2.setDelFlag(false);
					personInfo2.setCreateTime(new Date());
					personInfo2.setPopedom("1");
					personInfo2.setWechatNoticeEnabled(false);
					personInfo2.setAllowViewLocal(false);
					personInfo2.setGuestEnabled(true);
					personInfoDAO.insert(personInfo2);
					return personInfo2;
				}else {
					return personInfo1;
				}


			}else {
				return personInfo;
			}


		}
		else {
			return personInfo;
		}
	}

	@Override
	public List<PersonInfo> notGuestList() {
		return personInfoDAO.notGuestList();
	}
}