package com.jpsoft.smart.modules.business.dao;

import java.util.Date;
import java.util.List;

import com.jpsoft.smart.modules.base.entity.PersonInfo;
import org.joda.time.DateTime;
import org.springframework.stereotype.Repository;
import com.jpsoft.smart.modules.business.entity.WorkAttendance;
import java.util.Map;
import com.jpsoft.smart.modules.common.dto.Sort;

@Repository
public interface WorkAttendanceDAO {
	int insert(WorkAttendance entity);
	int update(WorkAttendance entity);
	int exist(String id);
	WorkAttendance get(String id);
	int delete(String id);
	List<WorkAttendance> list();
	List<WorkAttendance> search(Map<String,Object> searchParams,List<Sort> sortList);
    List<WorkAttendance> findByPersonIdAndDate(Long personId, Date startDate, Date endDate);
    int deleteByCompanyCodeAndDate(String companyCode, Date startDate, Date endDate);
    List<WorkAttendance> findByPeriod(Long personId, String alarmConfigId, Date recordTime);
	List<PersonInfo> queryUnAttendanceList(String companyCode, Date startDate, Date endDate);
}