package com.jpsoft.smart.modules.business.entity;

import java.util.Date;

import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;

/**
  描述:business_fill_attendance的实体类
 */
@Data
@ApiModel(value = "business_fill_attendance的实体类")
public class FillAttendance {
	/**
	 * 编号
	 */
	@ApiModelProperty(value = "编号")
	private String id;
	/**
	 *申请人ID
	 */
	@ApiModelProperty(value = "申请人ID")
	private Long personId;
	/**
	 *申请人姓名
	 */
	@ApiModelProperty(value = "申请人姓名")
	private String personName;
	/**
	 *申请人ID
	 */
	@ApiModelProperty(value = "编号")
	private String companyName;
	/**
	 *申请类型:外勤打卡、补卡
	 */
	@ApiModelProperty(value = "申请类型:外勤打卡、补卡")
	private String type;
	/**
	 *申请类型翻译
	 */
	@ApiModelProperty(value = "申请类型翻译")
	private String typeN;
	/**
	 *补卡日
	 */
	@ApiModelProperty(value = "补卡日")
	private String fillDay;
	/**
	 *补卡时间
	 */
	@ApiModelProperty(value = "补卡时间")
	private String fillAttendanceTime;
	/**
	 *内容
	 */
	@ApiModelProperty(value = "内容")
	private String content;
	/**
	 *审核人ID
	 */
	@ApiModelProperty(value = "审核人ID")
	private Long approvalPersonId;
	/**
	 *审核人姓名
	 */
	@ApiModelProperty(value = "审核人姓名")
	private String approvalPersonName;
	/**
	 *状态
	 */
	@ApiModelProperty(value = "状态")
	private String status;
	/**
	 *创建人
	 */
	@ApiModelProperty(value = "创建人")
	private String createBy;
	/**
	 * 创建时间
	 */
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
	@ApiModelProperty(value = "创建时间")
	private Date createTime;
	/**
	 *更新人
	 */
	@ApiModelProperty(value = "更新人")
	private String updateBy;
	/**
	 * 更新时间
	 */
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
	@ApiModelProperty(value = "更新时间")
	private Date updateTime;
	/**
	 *删除状态
	 */
	@ApiModelProperty(value = "删除状态")
	private Boolean delFlag;
}