package com.jpsoft.smart.modules.business.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;

import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
 * 描述:business_work_attendance的实体类
 */
@Data
@ApiModel(value = "business_work_attendance的实体类")
public class WorkAttendance implements Serializable {
    /**
     * 缺卡
     */
    public static final String MISSING = "0";

    /**
     * 正常打卡
     */
    public static final String SUCCESS = "1";

    /**
     * 迟到
     */
    public static final String LATE = "2";

    /**
     * 早退
     */
    public static final String LEAVE_EARLY = "3";

    /**
     * 主键
     */
    @ApiModelProperty(value = "主键")
    private String id;
    /**
     * 考勤设置编号
     */
    @ApiModelProperty(value = "考勤设置编号")
    private String alarmConfigId;
    /**
     * 0-缺卡，1-正常，2-迟到，3-早退
     */
    @ApiModelProperty(value = "0-缺卡，1-正常，2-迟到，3-早退")
    private String result;
    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    private String createBy;
    /**
     * 创建时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 更新人
     */
    @ApiModelProperty(value = "更新人")
    private String updateBy;
    /**
     * 更新时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;
    /**
     * 是否删除
     */
    @ApiModelProperty(value = "是否删除")
    private Boolean delFlag;

    /**
     * 人员编号
     */
    @ApiModelProperty(value = "人员编号")
    private Long personId;

    /**
     * 记录时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "记录时间")
    private Date recordTime;


    /**
     * 记录温度
     */
    @ApiModelProperty(value = "记录温度")
    private BigDecimal temperature;

    @ApiModelProperty(value = "上班-1,下班-2")
    private Integer classifier;
}