package com.jpsoft.smart.modules.business.service;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import java.util.Map;

import com.jpsoft.smart.modules.base.entity.PersonInfo;
import com.jpsoft.smart.modules.business.entity.WorkAttendance;
import com.github.pagehelper.Page;
import com.jpsoft.smart.modules.common.dto.Sort;

public interface WorkAttendanceService {
	WorkAttendance get(String id);
	boolean exist(String id);
	int insert(WorkAttendance model);
	int update(WorkAttendance model);
	int delete(String id);
	List<WorkAttendance> list();
	Page<WorkAttendance> pageSearch(Map<String, Object> searchParams,int pageNum,int pageSize,boolean count,List<Sort> sortList);
    List<WorkAttendance> findByPersonIdAndDate(Long personId, Date startDate, Date endDate);
    int deleteByCompanyCodeAndDate(String companyCode, Date startDate, Date endDate);

	/**
	 * 打卡
	 * @param personId
	 * @param recordDate
	 */
	boolean punchIn(Long personId, BigDecimal temperature,Date recordDate);

    List<PersonInfo> queryUnAttendanceList(String companyCode, Date startDate, Date endDate);
}