package com.jpsoft.smart.config;

import org.springframework.amqp.core.Binding;
import org.springframework.amqp.core.BindingBuilder;
import org.springframework.amqp.core.DirectExchange;
import org.springframework.amqp.core.Queue;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

@Configuration
public class RabbitmqConfig {
    @Bean
    public Queue importImageQueue() {
        return new Queue("importImageQueue",true);  //true 是否持久
    }

    @Bean
    DirectExchange importImageExchange() {
        return new DirectExchange("importImageExchange");
    }

    //绑定  将队列和交换机绑定, 并设置用于匹配键：TestDirectRouting
    @Bean
    Binding bindingDirect() {
        return BindingBuilder.bind(importImageQueue()).to(importImageExchange()).with("importImage");
    }
}
