package com.jpsoft.smart.listener;

import com.jpsoft.smart.config.ElectricityParamConfig;
import com.jpsoft.smart.config.LapiParamConfig;
import com.jpsoft.smart.electricity.server.ElectricityTcpServer;
import com.jpsoft.smart.lapi.LapiTcpServer;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;
import javax.servlet.annotation.WebListener;

@WebListener
@Component
public class WebStateListener implements ServletContextListener {
    @Autowired
    private ElectricityTcpServer electricityTcpServer;

    @Autowired
    private ElectricityParamConfig electricityParamConfig;

    @Autowired
    private LapiTcpServer lapiTcpServer;

    @Autowired
    private LapiParamConfig lapiParamConfig;

    @Override
    public void contextDestroyed(ServletContextEvent arg0) {
        // TODO Auto-generated method stub
        System.out.println("web应用销毁");

//        if(electricityTcpServer!=null) {
//            electricityTcpServer.stop();
//        }

        if (lapiTcpServer!=null){
            lapiTcpServer.stop();
        }
    }

    @Override
    public void contextInitialized(ServletContextEvent arg0) {
        // TODO Auto-generated method stub
        System.out.println("web应用初始化");

//        if(electricityTcpServer!=null) {
//            electricityTcpServer.start(electricityParamConfig.getPort());
//        }

        if (lapiTcpServer!=null){
            lapiTcpServer.start(lapiParamConfig.getPort());
        }
    }
}