package com.jpsoft.smart;

import cn.hutool.core.date.DateField;
import cn.hutool.core.date.DateUtil;
import com.github.pagehelper.Page;
import com.jpsoft.smart.modules.base.dao.CheckNumCompanyDAO;
import com.jpsoft.smart.modules.base.dao.PersonInfoDAO;
import com.jpsoft.smart.modules.base.dao.TotalCheckCompanyDAO;
import com.jpsoft.smart.modules.base.entity.CheckNumCompany;
import com.jpsoft.smart.modules.base.entity.CompanyInfo;
import com.jpsoft.smart.modules.base.entity.PersonDeviceRelation;
import com.jpsoft.smart.modules.base.entity.TotalCheckCompany;
import com.jpsoft.smart.modules.base.service.CompanyInfoService;
import com.jpsoft.smart.modules.base.service.PersonDeviceRelationService;
import com.jpsoft.smart.modules.common.dto.Sort;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.*;

/**
 * @author 墨鱼_mo
 * @date 2020-3-27 11:25
 */
@RunWith(SpringRunner.class)
@SpringBootTest
public class CheckNumCompanyTest {

    @Autowired
    private CheckNumCompanyDAO checkNumCompanyDAO;

    @Autowired
    private TotalCheckCompanyDAO totalCheckCompanyDAO;

    @Autowired
    private PersonInfoDAO personInfoDAO;

    @Autowired
    private CompanyInfoService companyInfoService;

    @Autowired
    private PersonDeviceRelationService personDeviceRelationService;

    @Test
    public void testGet(){
       // CheckNumCompany checkNumCompany = checkNumCompanyDAO.get(1L);
        List<CheckNumCompany> list = checkNumCompanyDAO.findByRecordTime("2020-03-28");
        System.out.println(list);
    }

    @Test
    public void testList(){
        List<CheckNumCompany> list = checkNumCompanyDAO.list();
        System.out.println(list);
    }

    @Test
    public void testGetDayCheckNum(){

        Integer  i = checkNumCompanyDAO.getDayCheckNum("2020-03-26");
        System.out.println(i==null?0:i);
    }

    @Test
    public void testFindMinNormal(){
        Integer i = totalCheckCompanyDAO.findMinNormalDay();
        System.out.println(i);
    }

    @Test
    public void testCountByCompanyListAndPopedom(){
        List<CompanyInfo> list = companyInfoService.list();
        Long i = personInfoDAO.countByCompanyListAndPopedom("%2%",list);
        System.out.println(i);
    }


    @Test
    public void testPersonDevicePage(){


        List<PersonDeviceRelation> list =personDeviceRelationService.findByIsBoundAndUpdateTime(DateUtil.offset(new Date(),DateField.DAY_OF_MONTH, -1),50);

        System.out.println(list);
        System.out.println(list.size());
    }
}
